//+------------------------------------------------------------------+
//|                                                          EFX.mq4 |
//|                                   Copyright  2008, By Other Ltd,|
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,By Others Ltd"
#property link      "http://www.byothersltd.com/"
#include <stdlib.mqh>

extern int expertId=196308;
extern string EAName="EFX";

extern string PARAMETERS_FILTER = "PARAMETERS FILTER";
extern bool UseHourTrade = True;
extern int FromHourTrade = 9;
extern int ToHourTrade = 21;
extern int Work = 1;
//---- input parameters
extern int        EMATimeFrame    =  0;
extern int        Price           =  0;
extern int        EMAPeriod       = 1;
extern int        EMAShift        =  0;
extern bool   TradePositiveSwapOnly =True; // If true we take positive swap positions only
extern bool   PercentageExit =False; // If true we take positive swap positions only
extern double ProfitExit = 2; //% profit exit

extern int ATRStopPeriod = 14;
extern double ATRStopRatio = 2;
extern double ATRBreakevenStopRatio = 1;
extern int ATREnrtyPeriod =14;
extern double ATREntryRatio = 5;

extern double MovingPeriod       = 12;
extern double MovingShift        = 6;

extern string i0="_indicators params_";
extern string i1="__volatility__";
extern int rtP=7;
extern int Voltrp=9;
extern int Voltype=1;
extern double  VolatilityHL=13;

extern string i2="__rsi2ma__";
extern int MA1pr=5;
extern int MA1type=1;
/*
MODE_SMA       0     Simple moving average, 
MODE_EMA       1     Exponential moving average, 
MODE_SMMA      2     Smoothed moving average, 
MODE_LWMA      3     Linear weighted moving average.
*/
extern int MA2pr=8;
extern int MA2type=0;
extern int RSItpr=3;
extern double  MAofRSIUpHL=75;
extern double  MAofRSIDwnHL=25;


extern string i3="__deltastop__";
extern int     Mode=1; //0 - auto, 1 - manual
extern double  DeltaPrice=0.001;
extern int     ATRperiod=14;
extern double  ATRratio=2.824;

extern int    ConsecutiveTrades=3;

extern double Lots = 0.1;
extern int    LotRound=1; //digits after decimal point for lot size
extern double MinLot = 0.1;    //minimum lot size
extern double MaximumRisk = 2; //% risk. lot size will be calculated so that stoploss was equal to risk% of balance
extern bool   FixedLot = false; //trigger to use MM

extern int    slippage=2;   	//slippage for market order processing
extern int    shift=0;			//shift to current bar for entry 
extern int    OrderTriesNumber=3;

bool buysig,sellsig,closebuy,closesell,cancel,addbuy,addsell,exit,tickvalue; 
int ord,tries,last,buys,sells,SL;
double atrstop,atrentry,_1stentry,entryprice,_1stlots,avgpositionprofit,hbuy,lsell,curprof,ma;
bool Buy_Enabled=True;
bool Sell_Enabled=True;
int init(){
  {


   //----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   expertId    = subGenerateMagicNumber(expertId, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE);
   
//----
   return(0);
 }
 }
 
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()  {
      if (UseHourTrade){
   if((Hour()>=FromHourTrade)&&(Hour()<=ToHourTrade))
      Comment("Trading Hours");
   else
     {
      Comment("Non-trading Hours");
      return(0);
     }
   }
   //---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

   ord=CalculateCurrentOrders();
   //---- check for signals
   CheckForSignals();

   if (ord!=0) CheckForClose();

   CheckForOpen();
   CommentMe();
   BreakevenStop();
   
   if (ScanTrades()<1) return(0);
   else
   if (EMAPeriod >0) TrailStop(); 

      if (TradePositiveSwapOnly == true)
    {
     if (MarketInfo(Symbol(), MODE_SWAPLONG) > 0) 
      {
       Buy_Enabled = True;
      }
      else
      {
       Buy_Enabled = False;
      }
     if (MarketInfo(Symbol(), MODE_SWAPSHORT) > 0)
      {
       Sell_Enabled = True;  
      }
      else
      {
       Sell_Enabled = False;
      }
    }
}


//------------------------------------------------- FILE READ ONLY FUNCTION -----------------------------------

double MaxMarginFileRead.CM()
{
  int handle;
  double last=0;
  handle=FileOpen("margin_CT_data.csv",FILE_CSV|FILE_READ);
  if(handle>0)
    {
     last=FileReadNumber(handle);
     FileClose(handle);
    }
   if(handle<0)
    {
     Print("cant open file error-",GetLastError());
    }
return(last);
}

//------------------------------------------------- FILE WRITE ONLY FUNCTION ----------------------------------

double MaxMarginFileWrite.CM()
{
  int handle;
  double CurrMargin=AccountMargin();
  handle=FileOpen("margin_CT_data.csv", FILE_CSV|FILE_WRITE,';');
  if(handle<1)
    {
     Print("cant open file error-",GetLastError());
     return(0);
    }
  FileWrite(handle, CurrMargin, DOUBLE_VALUE);
  FileClose(handle);
 return(0);

  }
//+------------------------------------------------------------------+

//--------------------------------------------------------------------------------------------------------------


//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()  {
   buys=0; sells=0; avgpositionprofit=0; hbuy=0; lsell=99999; curprof=0;
   string symbol=Symbol();
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==expertId) {
         curprof += OrderProfit()+OrderSwap();
         if(OrderType()==OP_BUY || OrderType()==OP_BUYSTOP)  buys++;
         if(OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) sells++;
         if (OrderType()==OP_BUY) { avgpositionprofit+=OrderClosePrice()-OrderOpenPrice(); hbuy=MathMax(hbuy,OrderOpenPrice()); }
         if (OrderType()==OP_SELL) { avgpositionprofit+=-OrderClosePrice()+OrderOpenPrice(); lsell=MathMin(lsell,OrderOpenPrice()); }
      }
   }
   if (buys+sells!=0) avgpositionprofit=avgpositionprofit/(buys+sells);
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
}

double LotsRisk(int StopLoss)  { 
   //MM lot size calculation
   int sl=StopLoss;
   if (sl==0) sl=100;
   double lot=Lots;
//---- select lot size
   if (!FixedLot)
      lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk*0.001/sl,LotRound);
   else
      lot=Lots;
//---- return lot size
   if(lot<MinLot) lot=MinLot;
   return(lot);
}

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForSignals() {

      addsell=false;
      addbuy=false;
      buysig=false;
      sellsig=false;
      closebuy=false;
      closesell=false;
      exit=false;
 
   	double VolCH=iCustom(NULL,0,"volatility",rtP,Voltrp,Voltype,0,shift);
   	double RSIndex1=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift);
   	double MAofRSI11=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift);
   	double MAofRSI21=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift);
   	double RSIndex2=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,0,shift+1);
   	double MAofRSI12=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,1,shift+1);
   	double MAofRSI22=iCustom(NULL,0,"rsi2ma",MA1pr,MA1type,MA2pr,MA2type,RSItpr,2,shift+1);
   	double TrStop=iCustom(NULL,0,"delta-stop",Mode,DeltaPrice,ATRperiod,ATRratio,0,shift);
   	double ma=iMA(NULL,0,MovingPeriod,MovingShift,MODE_SMA,PRICE_CLOSE,0);

   	atrstop=iATR(NULL,0,ATRStopPeriod,shift);
   	atrentry=iATR(NULL,0,ATREnrtyPeriod,shift);

      if (ord==0) { _1stentry=-1; _1stlots=0; }
      int numentries;
      if (ord>0) {
         if (atrentry*ATREntryRatio!=0.0) numentries = MathFloor((Ask-_1stentry)/(atrentry*ATREntryRatio));
         if (numentries>ord) addbuy=true;
      }
      if (ord<0) {
         if (atrentry*ATREntryRatio!=0.0) numentries = MathFloor((_1stentry-Bid)/(atrentry*ATREntryRatio));
         if (numentries>(-ord)) addsell=true;
      }
      SL=atrstop*ATRStopRatio/Point;
      
      double VolHL=VolatilityHL;

      double HL1=MAofRSIUpHL;
      double HL2=MAofRSIDwnHL;
      double HLM=50;


      //bool Long = cross(MAofRSI,MAofRSI2) and VolCH>VolHL and RSIndex<HLM and RSIndex>HL2 and TrStop<C;
      bool Long1 = MAofRSI11>MAofRSI21 && MAofRSI12<=MAofRSI22 && VolCH>VolHL && RSIndex1<HLM && RSIndex1>HL2 && TrStop<Close[shift] && Open [0]>ma;
      //bool Short = cross(MAofRSI2,MAofRSI) and VolCH>VolHL and RSIndex<HL1 and RSIndex>HLM and TrStop>C;
      bool Short1 = MAofRSI11<MAofRSI21 && MAofRSI12>=MAofRSI22 && VolCH>VolHL && RSIndex1<HL1 && RSIndex1>HLM && TrStop>Close[shift] && Open [0]<ma;
      //bool Long2 = cross(MAofRSI,HLM) and cross(MAofRSI2,HLM) and VolCH>VolHL;
      bool Long2 = MAofRSI11>HLM && MAofRSI12<=HLM && MAofRSI21>HLM && MAofRSI22<=HLM && VolCH>VolHL && Open [0]>ma;
      //bool Short2 = cross(HLM,MAofRSI) and cross(HLM,MAofRSI2) and VolCH>VolHL;
      bool Short2 = MAofRSI11<HLM && MAofRSI12>=HLM && MAofRSI21<HLM && MAofRSI22>=HLM && VolCH>VolHL && Open [0]<ma;
      //bool Long3 = RSIndex-ref(RSIndex,-1)>20;
      bool Long3 = RSIndex1-RSIndex2>20 && Open [0]>ma;
      //bool Short3 = ref(RSIndex,-1)-RSIndex>20;
      bool Short3 = RSIndex2-RSIndex1>20 && Open [0]<ma;



      buysig = Long1 || Long2 || Long3;
      sellsig = Short1 || Short2 || Short3;

      closebuy=sellsig;
      closesell=buysig;
      
      
      if (PercentageExit == true){
      if (curprof>=AccountBalance()*ProfitExit/100.0) {
      exit=true;
      
}
}
}
void CheckForOpen() {

   int    res;
   double entry,stop,profit;
   
   if (exit) return;
   
//---- buy conditions
   if (addbuy)  {
		res=OpenAtMarket(OP_BUY,_1stlots);
		if (res<=0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
		else AdjustStops();
   }
//---- sell conditions
   if (addsell)  {
		res=OpenAtMarket(OP_SELL,_1stlots);
		if (res<=0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
		else AdjustStops();
   }

   if (last==Time[0]) return;

   ord=CalculateCurrentOrders();

   if (ord!=0) CheckForClose();

   ord=CalculateCurrentOrders();

//---- buy conditions
   if (ord==0 && buysig)  {
		res=OpenAtMarket(OP_BUY,LotsRisk(SL));
		if (res<0) Print("Error opening BUY order : ",ErrorDescription(GetLastError()));
		else { last=Time[0]; _1stlots=LotsRisk(SL); _1stentry=entryprice; AdjustStops(); }
   }
//---- sell conditions
   if (ord==0 && sellsig)  {
		res=OpenAtMarket(OP_SELL,LotsRisk(SL));
		if (res<=0) Print("Error opening SELL order : ",ErrorDescription(GetLastError()));
		else { last=Time[0]; _1stlots=LotsRisk(SL); _1stentry=entryprice; AdjustStops(); }
   }
}
  
int OpenAtMarket(int mode,double lot) {
   int    res,tr,col;
   double openprice,sl,tp;
   tries=0;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELL) {
         openprice=Bid; 
         col=Red;
      } else {
         //openprice=nd(Ask);
         openprice=Ask;
         col=Blue;
      }
      entryprice=openprice;
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+expertId,expertId,0,col);
      tries++;
   }
   return(res);
}
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
	int total;
	total=OrdersTotal();
   for(int i=total;i>=0;i--) {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))  continue;
      if(OrderMagicNumber()!=expertId || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY && (exit || closebuy)) CloseAtMarket(OrderTicket(),OrderLots());
      if(OrderType()==OP_SELL && (exit || closesell)) CloseAtMarket(OrderTicket(),OrderLots());
      
   }
   if (exit) last=Time[0];
}

bool CloseAtMarket(int ticket,double lot) {
   bool bres=false; int tr;
   tries=0;
   while (!bres && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      bres=OrderClose(ticket,lot,OrderClosePrice(),slippage,White);
      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
      tries++;
   }
}

void AdjustStops() {
   ord=CalculateCurrentOrders();
   bool bres;
   double StopLoss;
   for (int i = 0; i < OrdersTotal(); i++) {
      if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != expertId )  continue;
      if ( OrderType() == OP_BUY ) {
         StopLoss = nd(hbuy-atrstop*ATRStopRatio);
         if ( StopLoss != OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
				   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
         }
      }

      if ( OrderType() == OP_SELL ) {
         StopLoss = nd(lsell+atrstop*ATRStopRatio);
         if ( StopLoss != OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
				   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
         }
      }
   }
   return;
}

void BreakevenStop() {
   ord=CalculateCurrentOrders();
   bool bres;
   double BEstop;
   double StopLoss=atrstop*ATRBreakevenStopRatio;
   if (avgpositionprofit<StopLoss) return;
   for (int i = 0; i < OrdersTotal(); i++) {
      if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
      if ( OrderSymbol() != Symbol() || OrderMagicNumber() != expertId )  continue;
      if ( OrderType() == OP_BUY ) {
         BEstop = nd(OrderOpenPrice()-StopLoss);
         if ( BEstop > OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), BEstop, OrderTakeProfit(), 0, White);
				   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
         }
      }

      if ( OrderType() == OP_SELL ) {
         BEstop = nd(OrderOpenPrice()+StopLoss);
         if ( BEstop < OrderStopLoss() ) {
               bres=OrderModify (OrderTicket(), OrderOpenPrice(), BEstop, OrderTakeProfit(), 0, Gold);
				   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
         }
      }
   }
   return;
}

double nd(double d) {
   return(NormalizeDouble(d,Digits));
}
// ---- Stepped Stops
void TrailStop()
{
   double minstop = MarketInfo(Symbol(),MODE_STOPLEVEL);
   double ask = MarketInfo(Symbol(),MODE_ASK);
   double bid = MarketInfo(Symbol(),MODE_BID);
   double ema = iMA(Symbol(),EMATimeFrame,EMAPeriod,0,MODE_SMA,Price,EMAShift);
   
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol()) 
      {
         if (mode==OP_BUY) 
         {
			double BuyStop = ema;
			if(OrderStopLoss() == 0 && SL > 0 ) BuyStop = Bid-SL*Point;  
			if((bid - BuyStop) < minstop*Point) BuyStop = bid - minstop*Point;   
			Print("MA=",ema," BuyStop=",BuyStop);
			   if ((OrderOpenPrice() <= BuyStop && BuyStop > OrderStopLoss()) || OrderStopLoss()==0) 
			   {
			   bool result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                             NormalizeDouble(BuyStop, Digits),
			                             OrderTakeProfit(),0,LightGreen);
			      if( !result )
               {
               Print("BUY: OrderModify failed with error #",GetLastError());
               }
			      return(0);
                          
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
         double SellStop = ema;   
         if (OrderStopLoss()==0 && SL > 0) SellStop = ask+SL*Point;
         if((SellStop-ask) < minstop*Point)  SellStop = ask + minstop*Point;  
         Print("MA=",ema," SellStop=",SellStop);   
            if( (OrderOpenPrice() >= SellStop && OrderStopLoss() > SellStop) || OrderStopLoss()==0) 
            {
            OrderModify(OrderTicket(), OrderOpenPrice(),
                        NormalizeDouble(SellStop, Digits),
			               OrderTakeProfit(),0,DarkOrange);
               if( !result )
               {
               Print("SELL: OrderModify failed with error #",GetLastError());
               }
               return(0);
               
   			}	    
         }
      }
   }     
}


// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELL) 
   numords++;
   }
   return(numords);
}
//----------------------------------------- COMMENT FUNCTION ----------------------------------------------------

int CommentMe()    //Comments out needed parameters on a chart
{
RefreshRates();
double Eq.CM = AccountEquity();
double Bal.CM = AccountBalance();
double Mar.CM = AccountMargin();
double Prof.CM = AccountProfit();
double TV.CM = MarketInfo(Symbol(), MODE_TICKVALUE);
double Sprd.CM = MarketInfo(Symbol(), MODE_SPREAD);
double SWL.CM = MarketInfo(Symbol(), MODE_SWAPLONG);
double SWS.CM = MarketInfo(Symbol(), MODE_SWAPSHORT);
double High.CM = iHigh(NULL,1440,1);
double Low.CM = iLow(NULL,1440,1);
double Close.CM = iClose(NULL,1440,1);
double BP = (High.CM+Low.CM+Close.CM)/3;
double BP.CM = (High.CM+Low.CM+Close.CM)/3;
double SLDst.CM = (entryprice-SL)*(-0.0001);
double Risking.CM = (SLDst.CM*TV.CM)*(1000);
double Lot.CM = (Lots);
double OldMar.CM = 0;
OldMar.CM = MaxMarginFileRead.CM();
if(Mar.CM>OldMar.CM)
MaxMarginFileWrite.CM();

Comment("Account balance is ",DoubleToStr(Bal.CM,2),"\n",
        "Account equity is ",DoubleToStr(Eq.CM,2),"\n",
        "Account profit is ",DoubleToStr(Prof.CM,2),"\n",
        "Account margin is ",DoubleToStr(Mar.CM,2),"\n",
        "Max Known Margin is ",DoubleToStr(OldMar.CM,2),"\n",
        "Tick Value is ",DoubleToStr(TV.CM,4),"\n",
        "Spread is ",DoubleToStr(Sprd.CM,0),"\n",
        "Lot Size is ",DoubleToStr(Lots,4),"\n",
        "Swap Long is ",DoubleToStr(SWL.CM,4),"\n",
        "Swap Short is ",DoubleToStr(SWS.CM,4),"\n",
        "Yesterdays Bar High is ",DoubleToStr(High.CM,4),"\n",
        "Yesterdays Bar Low is ",DoubleToStr(Low.CM,4),"\n",
        "Yesterdays Bar Close is ",DoubleToStr(Close.CM,4),"\n",
        "Bar Pivot is ",DoubleToStr(BP.CM,4),"\n",
        "SL Distance is ",DoubleToStr(SLDst.CM,4),"\n",
        "Money At Risk is ",DoubleToStr(Risking.CM,4),"\n",
        "Current time is ",TimeToStr(TimeCurrent()));

return(0);
}
//+------------------------------------------------------------------+
//+--------------------------END OF PROGRAM--------------------------+


//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int Magic_Number, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "AUDCAD")       isymbol = 1;
   else if (symbol == "AUDCHF")  isymbol = 2;
   else if (symbol == "AUDJPY")  isymbol = 3;
   else if (symbol == "AUDDKK")  isymbol = 4;
   else if (symbol == "AUDNZD")  isymbol = 5;
   else if (symbol == "AUDPLN")  isymbol = 6;
   else if (symbol == "AUDSGD")  isymbol = 7;
   else if (symbol == "AUDUSD")  isymbol = 8;
   else if (symbol == "CADCHF")  isymbol = 9;
   else if (symbol == "CADJPY")  isymbol = 10;
   else if (symbol == "CHFCAD")  isymbol = 11;
   else if (symbol == "CHFJPY")  isymbol = 12;
   else if (symbol == "CHFSGD")  isymbol = 13;
   else if (symbol == "EURAUD")  isymbol = 14;
   else if (symbol == "EURCAD")  isymbol = 15;
   else if (symbol == "EURCHF")  isymbol = 16;
   else if (symbol == "EURDKK")  isymbol = 17;
   else if (symbol == "EURGBP")  isymbol = 18;
   else if (symbol == "EURHKD")  isymbol = 19;
   else if (symbol == "EURHUF")  isymbol = 20;
   else if (symbol == "EURJPY")  isymbol = 21;
   else if (symbol == "EURLVL")  isymbol = 22;
   else if (symbol == "EURNOK")  isymbol = 23;
   else if (symbol == "EURNZD")  isymbol = 24;
   else if (symbol == "EURPLN")  isymbol = 25;
   else if (symbol == "EURSEK")  isymbol = 26;
   else if (symbol == "EURSGD")  isymbol = 27;
   else if (symbol == "EURSKK")  isymbol = 28;
   else if (symbol == "EURUSD")  isymbol = 29;
   else if (symbol == "EURZAR")  isymbol = 30;
   else if (symbol == "GBPAUD")  isymbol = 31;
   else if (symbol == "GBPCAD")  isymbol = 32;
   else if (symbol == "GBPCHF")  isymbol = 33;
   else if (symbol == "GBPDKK")  isymbol = 34;
   else if (symbol == "GBPJPY")  isymbol = 35;
   else if (symbol == "GBPNOK")  isymbol = 36;
   else if (symbol == "GBPNZD")  isymbol = 37;
   else if (symbol == "GBPSEK")  isymbol = 38;
   else if (symbol == "GBPSGD")  isymbol = 39;
   else if (symbol == "GBPUSD")  isymbol = 40;
   else if (symbol == "GBPZAR")  isymbol = 41;
   else if (symbol == "NZDCAD")  isymbol = 42;
   else if (symbol == "NZDCHF")  isymbol = 43;
   else if (symbol == "NZDJPY")  isymbol = 44;
   else if (symbol == "NZDSGD")  isymbol = 45;
   else if (symbol == "NZDUSD")  isymbol = 46;
   else if (symbol == "SGDJPY")  isymbol = 47;
   else if (symbol == "USDCAD")  isymbol = 48;
   else if (symbol == "USDCHF")  isymbol = 49;
   else if (symbol == "USDCCK")  isymbol = 50;
   else if (symbol == "USDDKK")  isymbol = 51;
   else if (symbol == "USDHKD")  isymbol = 52;
   else if (symbol == "USDHRK")  isymbol = 53;
   else if (symbol == "USDHUF")  isymbol = 54;
   else if (symbol == "USDJPY")  isymbol = 55;
   else if (symbol == "USDLVL")  isymbol = 56;
   else if (symbol == "USDLTL")  isymbol = 57;
   else if (symbol == "USDMXN")  isymbol = 58;
   else if (symbol == "USDNOK")  isymbol = 59;
   else if (symbol == "USDPLN")  isymbol = 60;
   else if (symbol == "USDSEK")  isymbol = 61;
   else if (symbol == "USDSGD")  isymbol = 62;
   else if (symbol == "USDSKK")  isymbol = 63;
   else if (symbol == "USDZAR")  isymbol = 64;
   else if (symbol == "#AA")  isymbol = 65;
   else if (symbol == "#AXP")  isymbol = 66;
   else if (symbol == "#BA")  isymbol = 67;
   else if (symbol == "#C")  isymbol = 68;
   else if (symbol == "#DD")  isymbol = 69;
   else if (symbol == "#DIS")  isymbol = 70;
   else if (symbol == "#AIG")  isymbol = 71;
   else if (symbol == "#GE")  isymbol = 72;
   else if (symbol == "#GM")  isymbol = 73;
   else if (symbol == "#HD")  isymbol = 74;
   else if (symbol == "#HON")  isymbol = 75;
   else if (symbol == "#HPQ")  isymbol = 76;
   else if (symbol == "#IBM")  isymbol = 77;
   else if (symbol == "#VZ")  isymbol = 78;
   else if (symbol == "#INTC")  isymbol = 79;
   else if (symbol == "#JNJ")  isymbol = 80;
   else if (symbol == "#JPM")  isymbol = 81;
   else if (symbol == "#KO")  isymbol = 82;
   else if (symbol == "#MCD")  isymbol = 83;
   else if (symbol == "#MMM")  isymbol = 84;
   else if (symbol == "#MO")  isymbol = 85;
   else if (symbol == "#MRK")  isymbol = 86;
   else if (symbol == "#MSFT")  isymbol = 87;
   else if (symbol == "#PG")  isymbol = 88;
   else if (symbol == "#T")  isymbol = 89;
   else if (symbol == "#PFE")  isymbol = 90;
   else if (symbol == "#UTX")  isymbol = 91;
   else if (symbol == "#WMT")  isymbol = 92;
   else if (symbol == "#XOM")  isymbol = 93;
   else if (symbol == "Gold")  isymbol = 94;
   else if (symbol == "Silver")  isymbol = 95;
   else if (symbol == "#EP")  isymbol = 96;
   else if (symbol == "#ENQ")  isymbol = 97;
   else if (symbol == "#YM")  isymbol = 98;
   else if (symbol == "#CL")  isymbol = 99;
   else if (symbol == "#NG")  isymbol = 100;
   else if (symbol == "#W")  isymbol = 101;
   else if (symbol == "#C")  isymbol = 102;
   else if (symbol == "#S")  isymbol = 103;
   else                          isymbol = 104;
   if(isymbol<10) Magic_Number = expertId * 10;
   return (StrToInteger(StringConcatenate(expertId, isymbol, timeFrame)));
   
}
//+------------------------------------------------------------------+